#include "hpscat.h"

_hcode  hcode;
_efont  efont;
_layout layout;
_cmode  cmode;
char    *nalza;
int     prows, fsize, width;
bool    to_stdout, nolnum, nobox, cont;

/**************
   initialize
 **************/

init(ac,av)
  int  *ac;
  char *av[];
{
    int  i;
    /*  set default parameters  */

    hcode  = KSC;
    efont  = Plain;
    fsize  = Defaultsize;
    layout = Garo;
    nobox  = False;
    nolnum = False;
    to_stdout = False;

    /*  process command line arguments  */

    i = 1;
    while(av[i]) {
	if(av[i][0] == '-') {
	    if(!strncmp(av[i], "-l3", 3))  layout = Garo3;
	    else if(!strncmp(av[i], "-c", 2))   to_stdout = True;
	    else if(!strncmp(av[i], "-l", 2))   goto next;
	    else if(!strncmp(av[i], "-p2", 3))  layout = Sero2;
	    else if(!strncmp(av[i], "-p",  2))  layout = Sero;
	    else if(!strncmp(av[i], "-nb", 3))  nobox = True;
	    else if(!strncmp(av[i], "-nl", 3))  nolnum = True;
	    else if(!strncmp(av[i], "-ks", 3))  goto next;
	    else if(!strncmp(av[i], "-N", 2))   hcode = Nbyte;
	    else if(!strncmp(av[i], "-16", 3))  hcode = Johap;
	    else if(!strncmp(av[i], "-i", 2))  hcode = ISO;
	    else if(!strncmp(av[i], "-bf", 3))  efont = Bold;
	    else if(!strncmp(av[i], "-fs", 3)) {
		int a = atoi(av[i]+3);
		if(a<Smallest||a>Largest) fatal("invalid font size");
		fsize = a;
	    }
	    else usage(av[0]);
	  next:
	    { /* shifting arguments */
	        int j;
	        for(j=i; j<*ac; j++) av[j] = av[j+1];
	    }
	    (*ac)--;
	}
	else i++;
    }
    if(nolnum) nobox = True;

    cont = False;
    switch(layout) {
      case Garo:  prows = L_height/fsize; width = L_width-S_width;  break;
      case Garo3: prows = L_height/fsize; width = L3_width-S_width; break;
      case Sero:  prows = P_height/fsize; width = P_width-S_width;  break;
      case Sero2: prows = P_height/fsize; width = P2_width-S_width; break;
    }
    setnalza();
}

setnalza()
{
    struct timeval  T;
    struct timezone tz;
    struct tm *Time;
    
    nalza = (char *)malloc(32);
    gettimeofday(&T, &tz);
    Time = (struct tm *) malloc(sizeof(struct tm));
    Time = localtime(&T.tv_sec);
    sprintf(nalza, "%d/%d/%d ,   %02d:%02d",
	    Time->tm_mon+1, Time->tm_mday, Time->tm_year,
	    Time->tm_hour,  Time->tm_min);
}

/***  EOF  ***/
