#include <errno.h>
#include "hpscat.h"

static converted;
char *tmpfn;

convert(s)
  char *s;
{
    char *args[5];  /* for execvp */
    int  i;
#ifdef  HPS
    if(hcode==KSC) {
#else
    if(hcode==Johap) {
#endif
        converted = 0;
        return 0;
    }
    tmpfn = tempnam("/tmp", "hpscat");
    for(i=0; i<4; i++)
        args[i] = (char *)malloc(256);
    strcpy(args[0], Converter);
    strcpy(args[2], s);
    strcpy(args[3], tmpfn);
    args[4] = (char *) 0;
    switch(hcode) {
#ifdef  HPS
      case Johap: strcpy(args[1], fromJH); break;
#else
      case KSC:   strcpy(args[1], fromKS); break;
#endif
      case Nbyte: strcpy(args[1], fromN); break;
      case ISO:   strcpy(args[1], fromI); break;
    }
    execute(args);
    fclose(fp);
    fp = fopen(tmpfn,"r");
    converted = 1;
    return 1;
}

execute(args)
  char **args;
{
    int  pid, status;
    if((pid=fork()) < 0) {
         perror("fork");
         exit(1);
    }
    if(pid==0) {
        execvp(args[0], args);
        perror("execvp");
        exit(1);
    }
    while(wait(&status)!=pid);
}

endfile()
{
    fclose(fp);
    if(ofp!=stdout) fclose(ofp);
    if(converted) unlink(tmpfn);
}

#define   U1    "\033[4m"  /* underline on  */
#define   U0    "\033[0m"  /* underline off */

char *ver = "1.3";

usage(prg)
  char *prg;
{
  fprintf(stderr,"\nHangul Printing Program for PostScript\t\tver %s\n",ver);
  fprintf(stderr,"\t\t\t\t\t\tby jbkang@csone.kaist.ac.kr\n");
  fprintf(stderr,"\n%s Usage :  %s [options] files ...%s\n\n",
    	U1, prg, U0);
  fprintf(stderr,"\t-c  : write output to stdout\n");
  fprintf(stderr,"\t      (default output is `filename.ps')\n\n");
  fprintf(stderr,"\t-l  : landscape 2 columns  <- %sdefault%s\n", U1, U0);
  fprintf(stderr,"\t-l3 : landscape 3 columns\n");
  fprintf(stderr,"\t-p  : portrait  1 column\n");
  fprintf(stderr,"\t-p2 : portrait  2 columns\n\n");
  fprintf(stderr,"\t-ks : use KSC5601 hangul code  <- %sdefault%s\n", U1, U0);
  fprintf(stderr,"\t-N  : use N-byte hangul code\n");
  fprintf(stderr,"\t-16 : use johap hangul code\n");
  fprintf(stderr,"\t-i  : use ISO2022-1 hangul code\n\n");
  fprintf(stderr,"\t-bf : use boldface english font\n");
  fprintf(stderr,"\t-nb : do not print outline box\n");
  fprintf(stderr,"\t-nl : do not print outline box & line number\n\n");
  fprintf(stderr,"\t-fs#: set font size (%d~%d) <- %sdefault is -fs%d%s\n",
  	Smallest, Largest, U1, Defaultsize, U0);
  fprintf(stderr,"\t  * -fs is useful with -nl\n\n");
  exit(0);
}

fatal(s)
char *s;
{
    fprintf(stderr,"? %s\n", s);
    exit(1);
}

/***  EOF  ***/
